=== debian/changelog ===
srt (1.5.4-3) unstable; urgency=medium

  * [16dd739] d/{control,rules}: check the nocheck profile, fixing a FTCBFS.
    Thanks to Nilesh Patra <nilesh@debian.org> (Closes: #1116434)

 -- Florian Ernst <florian@debian.org>  Sun, 28 Sep 2025 13:10:20 +0200

srt (1.5.4-2) unstable; urgency=medium

  * [c549366] add d/patches/FTBFS_with_CMake_4.patch to fix exactly that
    (Closes: #1113542)
  * [e7cda77] d/control: Standards-Version: 4.7.2 (no changes required)
  * [5a89c50] d/control: drop now redundant Rules-Requires-Root: no

 -- Florian Ernst <florian@debian.org>  Thu, 25 Sep 2025 16:14:50 +0200

srt (1.5.4-1) unstable; urgency=medium

  * [9ec29e2] New upstream version 1.5.4
  * [a8ee5c3] d/patches: refresh for new upstream release

 -- Florian Ernst <florian@debian.org>  Wed, 13 Nov 2024 16:27:08 +0100

srt (1.5.3-2) unstable; urgency=medium

  * [0bc278e] d/control: B-D pkg-config -> pkgconf
  * [9154f06] d/copyright: clarify that some parts are dual-licensed
  * [2af4f41] d/control: correct hard dependencies for dev packages.
    Thanks to Laurent Bigonville <bigon@debian.org> (Closes: #1086751)
  * [5f509fc] d/copyright: update years

 -- Florian Ernst <florian@debian.org>  Tue, 05 Nov 2024 12:19:15 +0100
