=== debian/control ===
Source: srt
Priority: optional
Maintainer: Florian Ernst <florian@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 help2man,
 libgnutls28-dev,
 libgtest-dev <!nocheck>,
 libssl-dev,
 pkgconf,
Build-Depends-Indep: python3-sphinx
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/Haivision/srt
Vcs-Browser: https://salsa.debian.org/debian/libsrt
Vcs-Git: https://salsa.debian.org/debian/libsrt.git

Package: libsrt1.5-openssl
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by OpenSSL.

Package: libsrt1.5-gnutls
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 SSL support is provided by GnuTLS.

Package: libsrt-openssl-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libsrt-gnutls-dev, libsrt-dev
Depends: libsrt1.5-openssl (= ${binary:Version}),
         libssl-dev (>= 1.1),
         ${misc:Depends},
Suggests: libsrt-doc (= ${source:Version}),
Description: Secure Reliable Transport UDP streaming library (OpenSSL flavour development)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.5
 SSL support is provided by OpenSSL.

Package: libsrt-gnutls-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Conflicts: libsrt-openssl-dev, libsrt-dev
Depends: libgnutls28-dev,
         libsrt1.5-gnutls (= ${binary:Version}),
         nettle-dev,
         ${misc:Depends},
Suggests: libsrt-doc (= ${source:Version}),
Description: Secure Reliable Transport UDP streaming library (GnuTLS flavour development)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains development files for libsrt1.5-gnutls
 SSL support is provided by GnuTLS.

Package: libsrt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Secure Reliable Transport UDP streaming library (documentation)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains documentation files for libsrt1.5

Package: srt-tools
Architecture: any
Section: utils
Multi-Arch: foreign
Depends: libsrt1.5-gnutls (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: ffmpeg
Description: Secure Reliable Transport UDP streaming library (CLI tools)
 SRT is a latency-aware UDP transport mechanism optimized for video streams.
 It detects and compensates for jitter and bandwidth fluctuations due to
 network congestion. It mitigates packet loss and supports AES encryption.
 .
 This package contains CLI tools.
