=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/srt-$1\.tar\.gz/ https://github.com/Haivision/srt/tags .*/v?(\d\.\d\.\d*)\.tar\.gz
