## srt deepl-0.9.1

=== requirements.txt ===
easygui==0.98.2
geckodriver-autoinstaller==0.1.0
selenium==3.141.0
srt==3.4.1
urllib3==1.26.5
